# save/read in text mode
# all io functions come in pairs read_* assumes save_* was used

def save_perm(v, f):
    f.write(','.join(map(str,v)) + '\n')

def save_vector(v, f):
    f.write(''.join(map(str,v)) + '\n')

def save_matrix(M, f):
    for i in range(M.nrows()):
        save_vector(M[i], f)

def read_perm(f):
    l = f.readline()[:-1]
    return map(int, l.split(','))

def read_vector(F, f):
    return vector(F, f.readline()[:-1])

def read_matrix(F, f):
    L = []
    while True:
        l = f.readline()[:-1]
        if l == '':
            break
        L += [map(int,list(l))]
    return matrix(F, L)
